local addon = LibStub("AceAddon-3.0"):NewAddon("AO_BossMod", "AceEvent-3.0")
local version = "2.4"

local addonPrefix = "AOBossMod"
local lastPlayedTime = {}
local silenceDelay = 4

local debugMode = false

-- Bibliothèque de sons
local mediaPath = "Interface\\AddOns\\ao_bossmod\\medias\\"
local soundsTable = {
    "203096.ogg",
    "202977.ogg",
    "214348.ogg",
    "212707.ogg",
    "215300.ogg",
    "209915.ogg",
    "198006.ogg",
    "197969.ogg",
    "210290.ogg",
    "211073.ogg",
    "211471.ogg",
    "209034.ogg",
    "cac.ogg",
    "distance.ogg",
    "206788.ogg",
    "-13022.ogg",
    "209011.ogg",
    "209270.ogg",
    "211152.ogg",
    "204316.ogg"
}

-- ID's BigWigs
--- - NYTHENDRA
local NYTHENDRA_ROT = "203096" -- Pourriture
local NYTHENDRA_VOLATILE_ROT = "204463" -- Pourriture
local NYTHENDRA_BREATH = "202977" -- Souffle
--- - ELERETHE RENFERAL
local ELERETH_AMBUSH = "214348" -- Ambush
local ELERETH_ROC = "212707" -- P2
local ELERETH_SPIDER = "215300" -- P1
--- - ILLGYNOTH
local ILLGYNOTH_RECONSTITUTION = "209915" -- Sortez
--- - CENARIUS
local CENARIUS_RONCES = "210290" -- Ronces
local CENARIUS_PIETINEMENT = "211073" -- Pétinement
local CENARIUS_TOUCHER = "211471" -- Toucher d'infamie
--- - XAVIUS
local XAVIUS_LIENS = "209034" -- Liens

-- SKORPYRON
local SKORPYRON_SHOCKWAVE=204316
-- CHRONOMATIC ANOMALY
local CHRONOMATIC_ADD=-13022
-- TRILLIAX
local TRILLIAX_TOXIC_SLICE=206788
-- GULDAN
local GULDAN_EYE_OF_GULDAN=209270
local GULDAN_EMP_EYE_OF_GULDAN=211152
local GULDAN_BONDS_OF_FEL=209011 -- liens

-- Menu de configuration
local soundToTest
local options = {
    type = "group",
    args = {
        enable = {
            name = "Activer AO BossMod",
            desc = "Activer / désactiver AO BossMod",
            type = "toggle",
            width = "full",
            set = function(info, val) addon.db.profile.enabled = val end,
            get = function(info) return addon.db.profile.enabled end
        },
        soundChannel = {
            name = "Canal",
            desc = "Canal audio pour les annonces vocales et les alertes",
            type = "select",
            order = 1,
            values = {
                Master = "Master",
                SFX = "SFX",
                Ambience = "Ambience",
                Music = "Music"
            },
            set = function(info, val) addon.db.profile.soundchannel = val end,
            get = function(info) return addon.db.profile.soundchannel end
        },
        testVoice = {
            name = "Test",
            desc = "Tester les voix (sélectionner une alerte, puis cliquer sur GO!)",
            type = "select",
            order = 2,
            values = soundsTable,
            set = function(info, val) soundToTest = val end,
            get = function(info) return soundToTest end
        },
        goTestVoice = {
            name = "GO!",
            desc = "Ecouter l'alerte",
            type = "execute",
            order = 3,
            --func = function() if soundToTest then	addon:handleRaidInstruction(soundToTest, "Test Button") end end
            func = function() if soundToTest then PlaySoundFile(mediaPath .. soundsTable[soundToTest], addon.db.profile.soundchannel) end end
        },
        nythendra = {
            name = "CE : Nythendra",
            type = "group",
            order = 1,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                nythendraRot = {
                    name = "Pourriture",
                    desc = "Activer/désactiver l'alerte de la pourriture",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.nythendraRot = val end,
                    get = function(info) return addon.db.profile.nythendraRot end
                },
                nythendraBreath = {
                    name = "Souffle",
                    desc = "Activer/désactiver l'alerte du souffle",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.nythendraBreath = val end,
                    get = function(info) return addon.db.profile.nythendraBreath end
                }
            }
        },
        elerethe = {
            name = "CE : Elerethe Renferal",
            type = "group",
            order = 2,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                eleretheVilEmbush = {
                    name = "Vile embuscade",
                    desc = "Activer/désactiver l'alerte de la vile embuscade",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.eleretheVilEmbush = val end,
                    get = function(info) return addon.db.profile.eleretheVilEmbush end
                },
                eleretheRoc = {
                    name = "Phase piaf",
                    desc = "Activer/désactiver l'alerte du changement de phase",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.eleretheRoc = val end,
                    get = function(info) return addon.db.profile.eleretheRoc end
                },
                eleretheSpider = {
                    name = "Phase araignée",
                    desc = "Activer/désactiver l'alerte du changement de phase",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.eleretheSpider = val end,
                    get = function(info) return addon.db.profile.eleretheSpider end
                }
            }
        },
        illgynoth = {
            name = "CE : Illgynoth",
            type = "group",
            order = 3,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                illgynothReconstitution = {
                    name = "Reconstitution",
                    desc = "Activer/désactiver l'alerte du changement de phase",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.illgynothReconstitution = val end,
                    get = function(info) return addon.db.profile.illgynothReconstitution end
                }
            }
        },
        ursoc = {
            name = "CE : Ursoc",
            type = "group",
            order = 4,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                ursocCharge = {
                    name = "Charge",
                    desc = "Activer/désactiver l'alerte de la charge",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.ursocCharge = val end,
                    get = function(info) return addon.db.profile.ursocCharge end
                }
            }
        },
        cenarius = {
            name = "CE : Cenarius",
            type = "group",
            order = 6,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                cenariusRonces = {
                    name = "Ronces",
                    desc = "Activer/désactiver l'alerte des ronces",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.cenariusRonces = val end,
                    get = function(info) return addon.db.profile.cenariusRonces end
                },
                cenariusPietinement = {
                    name = "Piétinement",
                    desc = "Activer/désactiver l'alerte du piétinement",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.cenariusPietinement = val end,
                    get = function(info) return addon.db.profile.cenariusPietinement end
                },
                cenariusToucher = {
                    name = "Toucher d'infamie",
                    desc = "Activer/désactiver l'alerte du toucher d'infamie",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.cenariusToucher = val end,
                    get = function(info) return addon.db.profile.cenariusToucher end
                }
            }
        },
        xavius = {
            name = "CE : Xavius",
            type = "group",
            order = 7,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                xaviusLiens = {
                    name = "Liens de terreur",
                    desc = "Activer/désactiver l'alerte des liens de terreur",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.xaviusLiens = val end,
                    get = function(info) return addon.db.profile.xaviusLiens end
                }
            }
        },
        skorpyron = {
    name = "NH : Skorpyron",
    type = "group",
    order = 8,
    args = {
        alertsHeader = {
            name="Alertes sonores",
            type="description",
            fontSize="medium"
        },
        skorpyronShockwave = {
            name = "Shockwave",
            desc = "Activer/désactiver l'alerte",
            type = "toggle",
            width = "full",
            set = function(info, val) addon.db.profile.skorpyronShockwave = val end,
            get = function(info) return addon.db.profile.skorpyronShockwave end
        }
    }
},
        chronomatic = {
            name = "NH : Chronomatic Anomaly",
            type = "group",
            order = 9,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium",
                    order = 1
                },
                chronomaticAdds = {
                    name = "Adds",
                    desc = "Activer/désactiver l'alerte",
                    type = "toggle",
                    width = "full",
                    order = 2,
                    set = function(info, val) addon.db.profile.chronomaticAdds = val end,
                    get = function(info) return addon.db.profile.chronomaticAdds end
                }
            }
        },
        trilliax = {
            name = "NH : Trilliax",
            type = "group",
            order = 10,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                trilliaxToxicSlice = {
                    name = "Gateaux toxiques",
                    desc = "Activer/désactiver l'alerte",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.trilliaxToxicSlice = val end,
                    get = function(info) return addon.db.profile.trilliaxToxicSlice end
                }
            }
        },
        guldan = {
            name = "NH : Guldan",
            type = "group",
            order = 11,
            args = {
                alertsHeader = {
                    name="Alertes sonores",
                    type="description",
                    fontSize="medium"
                },
                guldanEyes = {
                    name = "Pop des yeux",
                    desc = "Activer/désactiver l'alerte",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.guldanEyes = val end,
                    get = function(info) return addon.db.profile.guldanEyes end
                },
                guldanBonds = {
                    name = "Pop des liens",
                    desc = "Activer/désactiver l'alerte",
                    type = "toggle",
                    width = "full",
                    set = function(info, val) addon.db.profile.guldanBonds = val end,
                    get = function(info) return addon.db.profile.guldanBonds end
                }
            }
        }
    }
}

-- Valeurs par défaut
local defaults = {
    profile = {
        enabled = true,
        nythendraRot = true,
        nythendraBreath = true,
        eleretheVilEmbush = true,
        eleretheRoc = true,
        eleretheSpider = true,
        illgynothReconstitution = true,
        ursocCharge = true,
        cenariusRonces = true,
        cenariusPietinement = true,
        cenariusToucher = true,
        xaviusLiens = true,
        skorpyronShockwave = true,
        chronomaticAdds = true,
        trilliaxToxicSlice = true,
        guldanEyes = true,
        guldanBonds = true,
        soundchannel = "Master"
    }
}

local function printDebug(text)
    if debugMode then print("[DEBUG][CLIENT] " .. text) end
end

function addon:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("AO_BossModDB", defaults, true)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("AO_BossMod", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AO_BossMod", "AO BossMod [Player]")
end

function addon:OnEnable()
    printDebug("AO Boss Mod Player init")
    self:RegisterEvent("CHAT_MSG_ADDON", "handleMessageAddon")
    RegisterAddonMessagePrefix(addonPrefix)
end

-- addon:CHAT_MSG_ADDON
-- Executé lors d'un évenement CHAT_MSG_ADDON
-- Vérifie qu'il s'agit d'un message AOBossMod, et que l'émetteur est un assistant ou le raid leader
function addon:handleMessageAddon(event, prefix, msg, channel, sender)
    --printDebug(event..prefix..msg..channel..sender)
    if prefix == addonPrefix and (UnitIsGroupAssistant(sender) or UnitIsGroupLeader(sender)) then
        if strfind(msg, "myAOBossModVersion") then return end -- pour éviter de traiter son propre wisp de réponse...
        if strfind(msg, "getAOBossModVersion") then
            self:handleGetVersion(sender)
        elseif strfind(msg, "takeScreenshot") then
            self:takeScreenshot()
        else
            if (self.db.profile.enabled) then self:handleRaidInstruction(msg, sender) end
        end
    end
end

-- handleRaidInstruction
-- Lance la lecture de l'instruction vocale envoyé par le raid lead
-- Zone de "silence" (variable silenceDelay) après chaque lecture, si jamais plusieurs assistants ont le module raid lead, ça évite de flood.
function addon:handleRaidInstruction(message, sender)

    -- Ici c'est laid, faut refaire un truc mieux que ça bobby...
    if (not self.db.profile.nythendraRot and (message == NYTHENDRA_ROT or message == NYTHENDRA_VOLATILE_ROT)) then return end
    if (not self.db.profile.nythendraBreath and message == NYTHENDRA_BREATH) then return end
    if (not self.db.profile.eleretheVilEmbush and message == ELERETH_AMBUSH) then return end
    if (not self.db.profile.eleretheRoc and message == ELERETH_ROC) then return end
    if (not self.db.profile.eleretheSpider and message == ELERETH_SPIDER) then return end
    if (not self.db.profile.illgynothReconstitution and message == ILLGYNOTH_RECONSTITUTION) then return end
    if (not self.db.profile.ursocCharge and message == "cac") then return end
    if (not self.db.profile.ursocCharge and message == "distant") then return end
    if (not self.db.profile.cenariusRonces and message == CENARIUS_RONCES) then return end
    if (not self.db.profile.cenariusPietinement and message == CENARIUS_PIETINEMENT) then return end
    if (not self.db.profile.cenariusToucher and message == CENARIUS_TOUCHER) then return end
    if (not self.db.profile.xaviusLiens and message == XAVIUS_LIENS) then return end

    if (not self.db.profile.skorpyronShockwave and message == SKORPYRON_SHOCKWAVE) then return end
    if (not self.db.profile.chronomaticAdds and message == CHRONOMATIC_ADD) then return end
    if (not self.db.profile.trilliaxToxicSlice and message == TRILLIAX_TOXIC_SLICE) then return end
    if (not self.db.profile.guldanEyes and (message == GULDAN_EYE_OF_GULDAN or message == GULDAN_EMP_EYE_OF_GULDAN)) then return end
    if (not self.db.profile.guldanBonds and message == GULDAN_BONDS_OF_FEL) then return end

    printDebug("Receive message " .. message .. " from " .. sender)
    if (lastPlayedTime[message] == nil) or (time() - lastPlayedTime[message] > silenceDelay) then
        lastPlayedTime[message] = time()
        printDebug("Play sound " .. mediaPath .. message .. ".ogg on " .. self.db.profile.soundchannel)
        PlaySoundFile(mediaPath .. message .. ".ogg", self.db.profile.soundchannel)
    end
end

-- handleGetVersion
-- Le raid leader a envoyé une requête pour connaître la version du client
function addon:handleGetVersion(sender)
    printDebug("Receive message getAOBossModVersion from " .. sender)
    printDebug("Send Version " .. version .. " to " .. sender)
    SendAddonMessage(addonPrefix, "myAOBossModVersion " .. version, "WHISPER", sender)
end

function addon:takeScreenshot()
    printDebug("Receive screenshot instruction")
    Screenshot()
end
